import json, httplib
from datetime import datetime

def load():
    #possible parameters of the app.
    optimizers = ['em','online']
    db  = ['100db.txt']
    cores = [1,2,4,8,16]
    apps = []
    for data in db:
        for opt in optimizers:
            for c in cores:
                apps = apps + [data+opt+str(c).zfill(2)]
                
    #direction and port of the server
    connection = httplib.HTTPConnection('reed.pc.ac.upc.edu',8080)
    connection.connect()
    #API call 
    connection.request('GET','/api/v1/applications')
    #Read the result of the call
    result = json.loads(connection.getresponse().read())
    times = []
    #for each app
    for app in apps:
        #search the app in the api response 
        for i in range(len(result)):
            if app in result[i].values():
                #get the value from the datason and store it in times
                times =times + [parsedata(app, result[i])]
                #We already have the app we can start looking for the next one.
                break
    #We format the info of the app
    final = []
    for app in times:
        size = app[0][0:3]
        numCores = app[0][-2:]
        if app[0].find('em')>0:
            opt = 'em'
        else:
            opt = 'online'
        final = final + [[app[0],app[1], size, numCores,opt]]

    #return the information
    return final 
        
#get the time from the json format
def parsedata(app, info):
    s = info['attempts'][0]['startTime']
    form = s[0:s.find('T')]+' '+s[11:s.find('G')]
    timeInicial = datetime.strptime(form, "%Y-%m-%d %H:%M:%S.%f")

    s = info['attempts'][0]['endTime']
    form = s[0:s.find('T')]+' '+s[11:s.find('G')]
    timeFinal = datetime.strptime(form, "%Y-%m-%d %H:%M:%S.%f")

    return [app,format((timeFinal - timeInicial).total_seconds(),'.3f')]

#save the information to a txt.
def save(matrix):
    out = ""

    for row in matrix:
        for cell in row:
            out = out + str(cell) + " ; "
        out += "\n"

    with open("out.txt","wt") as file:
        file.write(out)
    
    

